﻿using System;
using System.Collections.Generic;
using Life.Misc;

namespace Life.Automaton
{
    public delegate Cell[,] Rule(IField old);
    
    public interface IField : IObservable<IField>
    {
        Size Size { get; }

        Cell this[int x, int y] { get; }

        IEnumerable<Cell> Cells { get; }

        IEnumerable<Cell> Neighbours(int x, int y);

        void Transform(Rule rule);
        void Notify();
    }
}